# Tags Changes

## 0.1.3

- Updated to SDK 0.5.20.2_r24160.
- Prefix all library names with `tags`; for example `tags.html`.

## 0.1.2

- Added the function `append` in the `html` library; this provides a means to
append existing elements in a tag builder expression.
- Expose the `bind` function in the `custom` library; this is a convenience
function for implementors of custom tags.

## 0.1.1

- Updated to SDK 0.5.13_r23552.
- Added `<nav>` tag.
- Added an optional `args` to each `Tag`.  In the `html` library these are 
ignored.  In the `custom` library we have defined a `Bind` function type which
we take as the `args` for our custom tags.  This gives us a mechanism to deliver 
the instance of `HasElement` back to the user as a workaround for the `xtag` 
issue noted in the prior version.
- Added an experimental `DropDown` custom tag; this is a work in progress.

## 0.1.0

- Updated to SDK 0.5.9_r22879.
- ToggleButton can no longer store itself in the `xtag` of its `element` as the
type constraint for `xtag` was tightened to `Element` in this SDK version.  We 
need to wait for the ability to extend `Element` and for the custom element work 
in `dart:html` to settle down before we can make any design changes here, so for
now there is no way to backtrack from the `element` to its ToggleButton.

## 0.0.9

- Updated to SDK 0.5.7_r22611.
- Avoid streaming ToggleButton `states` events unless there is a listener and 
the stream is not paused. This avoids potential memory leaks that might arise 
with buffered events.

## 0.0.8

- Updated to SDK 0.5.5_r22416.

## 0.0.7

- Updated to SDK 0.4.7_r21548.

## 0.0.6

- Export `dart:html` library from `html.dart` so that users have only 1 import.
- Added `custom.dart` library and a ToggleButton to the showcase example.  The 
`custom.dart` library aims to provide a canonical set of custom elements (web 
components).
- The `build` functon in the `builder.dart` library now takes a `Create`
function to build the tag's element.  This allows us to differentiate between a 
builder function called within the scope of a `Create` (constructor / 
initializer of an Element) and the scope of a `Build` (child appending logic).

## 0.0.5

- Removed `tags.dart` library; users should import `html.dart` directly.
- Added `builder.dart` library to expose tag builder functionality; This library 
may be used for user-defined custom tags.

## 0.0.4

- Added `<i>`, `<u>`, `<dl>`, `<dt>`, and `<dd>` tags.
- Added `Build` typedef and some documentation to the API.
- Added `documentation` to pubspec.

## 0.0.3

- Added `<b>` tag.
- Added `text(String)` builder function to perform `Element.appendText(String)`
from within `build()` closures.

## 0.0.2

- Added basic usage to the README.

## 0.0.1

- Initial release.
