
/// Custom tags.
library tags.custom;

import 'dart:async';
import 'builder.dart';
import 'html.dart';

part 'src/custom/drop_down.dart';
part 'src/custom/toggle_button.dart';

/// A function to bind to a custom element's [model].
///
/// Warning: once we are allowed to extend Element this is likely to be removed.
typedef void Bind(HasElement model);

final Tag dropDown = ([Build b, Bind onBind]) => 
    build(() => bind(new DropDown(), onBind), b);

final Tag toggleButton = ([Build b, Bind onBind]) => 
    build(() => bind(new ToggleButton(), onBind), b);

/// Call [onBind] with the given [model] and return the model's element.
Element bind(HasElement model, Bind onBind) {
  if (onBind != null) onBind(model);
  return model.element;
}

/// An object that has an element.
///
/// Warning: once we are allowed to extend Element this is likely to be removed.
abstract class HasElement {
  Element get element;
}
