
part of tags.custom;

class DropDown implements HasElement {
  
  final Element element = 
      div(() {
        shadow(() {
          content()..select='.toggle';
        });
      })..tabIndex = 0;
  
  ContentElement _content; 
  
  bool _open = false;
  bool get open => _open;
       set open(bool value) {
         if (value != _open) {
           _open = value;           
           if (_open) _content.select = '.toggle, .open';
           else _content.select = '.toggle';
           if (_states.hasListener && !_states.isPaused) _states.add(_open);
         }
       }
       
  final _states = new StreamController<bool>();
  Stream<bool> get states => _states.stream;
  
  DropDown() {
    element.onBlur.listen((_) => open = false);
    element.onClick.listen((_) => open = !_open);
    element.onKeyUp.listen((KeyboardEvent e) {
      if (e.keyCode == KeyCode.ESC) open = false;
      else if (e.keyCode == KeyCode.ENTER) open = true;
    });
    _content = element.shadowRoot.children[0];
  }
}
